import m from 'mithril';
import { Gauge } from 'components/widgets/gauge';
import { Pipe } from 'utilities/pipe';

require('./gauge-linear.css');

export class GaugeLinear extends Gauge {
	constructor(vnode: any) {
		super(vnode);
	}
	
	createSvg(svgElement: SVGElement) {
		let w = Math.round(svgElement.clientWidth);
		let h = Math.round(svgElement.clientHeight);
		
		svgElement.setAttribute('viewBox', "0 0 "+w+" "+h);

		let bg = document.createElementNS('http://www.w3.org/2000/svg', 'rect');
		bg.setAttribute('width', w.toString());
		bg.setAttribute('height', h.toString());
		bg.classList.add('gauge-bg');
		svgElement.append(bg);
		
		let barHeight = 15;
		const barGap = barHeight * 0.2;
		let numBars = Math.round(h / (barHeight + barGap));
		
		let bh = (h - (numBars+1)*barGap) / numBars;
		barHeight = Math.round(bh);
		
		for(let barIdx = 0; barIdx < numBars; ++barIdx) {
			let bar = document.createElementNS('http://www.w3.org/2000/svg', 'rect');
			bar.setAttribute('width', (w - barGap * 2).toString());
			bar.setAttribute('height', barHeight.toString());
			bar.classList.add('gauge-bar');
			bar.classList.toggle('lit', false);
			
			bar.setAttribute('x', barGap.toString());
			bar.setAttribute('y', (h - barIdx * (bh+barGap) - barGap - barHeight).toString());
			
			svgElement.append(bar);
			
			this.bars.push(bar);
		}
	}
	
	oncreate(vnode: any) {
		let svgElement: SVGElement = vnode.dom.querySelector('svg');
		this.createSvg(svgElement);
		
		super.oncreate(vnode);
	}
}
